#!/usr/bin/perl

# $Header$
# Cary Millsap (cary.millsap@hotsos.com)

# Show the wall time that corresponds to a given tim value

use strict;
use warnings;
use Date::Format qw(time2str);
use Date::Parse  qw(str2time);

my $usage = "Usage: $0 wall-time\n       $0 tim-value\n\t";
my $arg = shift or die $usage;     # tim or wall-time value
# printf "arg =%s\n", $arg;
if ($arg =~ /^[0-9]+$/) {
	# input argument is a tim value
	my $sec  = substr($arg, 0, length($arg)-6);
	my $msec = substr($arg, -6);
	# printf "sec =%s\n", $sec;
	# printf "msec=%s\n", $msec;
	printf "%s\n", time2str("%T.$msec %A %d %B %Y", $sec);
}
else {
	# input argument is a wall time value
	my $frac = ($arg =~ /\d+:\d+\.(\d+)/) ? $1 : 0;
	if ((my $l = length $frac) >= 6) {
		# if length(frac) >=6, then round
		$frac = sprintf "%06.0f", $frac/(10**($l-6));
	} else {
		# otherwise, right-pad with zeros
		$frac .= ('0' x (6-$l));
	}
	printf "%s%s\n", str2time($arg), $frac;
}

